#include "RHB_Custom.h"

ClassImp (RHB_Custom)

void  RHB_Custom::InitParams (void) 
{
	FEventProcessorThread::InitParams ();       	// call official function
							// and add user specific part :

	this->thvn = GetParam("HV_N_t");		// get a param already declared
        this->thvp = GetParam("HV_P_t");	
	this->t0hvn = this->thvn->GetValue();		// init intermediary parameters
        this->t0hvp = this->thvp->GetValue();
        this->t1hvn = this->thvn->GetValue();
        this->t1hvp = this->thvp->GetValue();

	this->Time_HV_N    = new FParamBrutSimple ();  // create new params
        this->Time_HV_N->SetName    ("Time_HV_N");
        this->AddRawParam (this->Time_HV_N);
        this->Time_HV_P    = new FParamBrutSimple ();
        this->Time_HV_P->SetName    ("Time_HV_P");
        this->AddRawParam (this->Time_HV_P);

}

void RHB_Custom::SetParamValues (void) 
{
	FEventProcessorThread::SetParamValues ();     //  call official function

	if(this->thvn->IsOn())
        {
                if(this->t0hvn<0) this->t0hvn=this->thvn->GetValue();
                if(this->t1hvn<0) this->t1hvn=this->thvn->GetValue();
                if(this->thvn->GetValue()-this->t1hvn>=1.0e9)
                {
                        this->t1hvn=this->thvn->GetValue();
                        this->Time_HV_N->SetValue((this->thvn->GetValue()-this->t0hvn)/1E9);
		}
	}

 	if(this->thvp->IsOn())
        {
                if(this->t0hvp<0) this->t0hvp=this->thvp->GetValue();
                if(this->t1hvp<0) this->t1hvp=this->thvp->GetValue();
                if(this->thvp->GetValue()-this->t1hvp>=1.0e9)
                {
                        this->t1hvp=this->thvp->GetValue();
                        this->Time_HV_P->SetValue((this->thvp->GetValue()-this->t0hvp)/1E9);
                }
        }

}


