



#include "RHB_Custom.h"




ClassImp (RHB_Custom)



void  RHB_Custom::InitParams (void) {

  FEventProcessorThread::InitParams ();       // call official function
                                              // and add user specific part :

  this->samples_2 = GetParam ("CH2_SAMPLES"); // get a param already declared

  this->qdc_tot   = new FParamBrutSimple ();  // create new params
  this->qdc_fast  = new FParamBrutSimple ();
  this->qdc_ratio = new FParamBrutSimple ();
  this->qdc_tot->SetName  ("Qtot");
  this->qdc_fast->SetName ("Qfast");
  this->qdc_ratio->SetName("Qratio");
  this->AddRawParam (this->qdc_tot);
  this->AddRawParam (this->qdc_fast);
  this->AddRawParam (this->qdc_ratio);

  this->nb_fast = 30;

}





void RHB_Custom::SetParamValues (void) {

  Double_t qtot  = 0.0;
  Double_t qfast = 0.0;
  Double_t val   = 0.0;
  Int_t    npts  = 0;

  FEventProcessorThread::SetParamValues ();                   //  call official function
                                                              //  and add user specific part :
                                                              //
  if (this->samples_2->IsOn ()) {                             //  when data is ch2 sampler data
    npts = this->samples_2->GetNbValues ();                   //    - get number of samples
    for (int i=0; i<npts; i++) {                              //    - calculate charges and ratio
      val = this->samples_2->GetValue (i);                    //
      qtot += val;                                            //
      if (i < this->nb_fast) qfast += val;                                 //
    }                                                         //
    this->qdc_tot->SetValue  (qtot);                          //    - update custom parameters
    this->qdc_fast->SetValue (qfast);                         //
    if (qtot != 0.0) this->qdc_ratio->SetValue (qfast/qtot);  //
  }

}



